
#INCLUDE "usgard.h"
 .org 0
name:
 .db "Diamonds v0.9",0

xc = TEXT_MEM          ; x coordinate
yc = TEXT_MEM+1        ; y coordinate
loc = TEXT_MEM+2        ; memory address
mloc = TEXT_MEM+4      ; matrix address
ssz = TEXT_MEM+6       ; sprite size
dir = TEXT_MEM+8       ; direction (up/down)
tmp = TEXT_MEM+10      ; temp variable
ovrflag = TEXT_MEM+13  ; game over flag
cblk = TEXT_MEM+14     ; current block
ta = TEXT_MEM+15       ; temp a
tb = TEXT_MEM+16       ; temp b
blks = TEXT_MEM+17     ; number of regular blocks left
lblks = TEXT_MEM+18    ; number of last blocks left 
winflag = TEXT_MEM+19 ; winner flag
lvs = TEXT_MEM+20      ; lives left
lev = TEXT_MEM+21      ; current level
level = TEXT_MEM2                ; current level matrix (84 bytes)
score = TEXT_MEM+25    ; score
tickc = TEXT_MEM+27    ; count between ticks
tick = TEXT_MEM+28     ; how many ticks left
xc2 = TEXT_MEM+30      
yc2 = TEXT_MEM+31      
startlev = TEXT_MEM+32 ; Start level
string = TEXT_MEM+40  ;for disphl

;------------ Beginning of ASM code ------------

;------------ Main Menu ------------
        ld              a,1
        ld              (startlev),a
        ld hl,GRAPH_MEM
        ld de,GRAPH_MEM+1
        ld (HL),0
        ld bc,1023
        ldir

menu:   
        call &           settop
        ld              bc,$1814+16
        ld              hl,&opt1
        CALL &DZM
        ld              bc,$1f14+16
        ld              hl,&opt2
        CALL &DZM
        ld              bc,$2614+16
        ld              hl,&opt3
        CALL &DZM
menulp: 
        call           GET_KEY
        cp 54   ;2nd Key
        jp &              z,strtgm
        cp 48  ;alpha key
        jr              z,sslev
        cp $37  ;exit key
        jr              nz,menulp
        ret

;---------- Setup the top of the screen ----------
settop: CALL CLEARLCD
        ld		b,$00
        ld        c,$08
        ld        d,128
        call	&	Hline
        ld              hl,$0400
        ld              (CURSOR_ROW),hl
        ld              hl,&name
        CALL D_ZT_STR

        ld              bc,$0901+26
        ld              hl,&abt
        CALL &DZM

        ld              bc,$0F01+24
        CALL &DZM

        ld              bc,$3801+26
        ld              hl,&hscr
        CALL &DZM
        ld              bc,$3800+66
        ld              hl,&highname
        CALL &DZM
	  ld hl,56*256+85
	  ld (CURSOR_X),hl
	  ld hl,(&HI_SCORE)
	  call &disphl
	   ret

;---------- Set Start Level ----------
sslev:  
        call &           settop
        ld              a,(startlev)
        ld              (ta),a
        ld              bc,$1714+16
        ld              hl,&sls
        CALL &DZM
        ld              bc,$1E14+16
        ld              hl,&phlp1
        CALL &DZM
        ld              bc,$2514+16
        ld              hl,&phlp2
        CALL &DZM
        ld              bc,$2C14+16
        ld              hl,&phlp3
        CALL &DZM
sllp:   ld a,(ta)
	  sub 10
	  jr nc,nopei
	  ld              bc,$1730+16  ;was 1730
        ld              hl,&blank
        CALL &DZM
nopei:
        ld hl,$1730-4+16
        ld (CURSOR_X),hl
	  ;ld              a,$2A
        ;ld              (CURSOR_X),a
        ld              a,(ta)
        LD H,0
        LD L,A
        call &disphl  ;display value in a at current position
        call           GET_KEY
        cp 54  ;2nd key, set level
        jr              z,ssl
        cp $04   ;up arrow, inc level
        jr              z,adslv
        cp $01  ;down arrow, dec level
        jr              z,sbslv
        cp $37  ;exit key, exit to main menu
        jp &              z,menu
        jr              sllp

sbslv:  ld              a,(ta)
        dec             a
        jr              nz,adslvc
        ld              a,27
        jr              adslvc
adslv:  
        ld              a,(ta)
        inc             a
        cp              28
        jr              nz,adslvc
        ld              a,$01
adslvc: ld              (ta),a
        jr              sllp
ssl:    ld              a,(ta)
        ld              (startlev),a
        jp &              menu

;------------ Set up the game ------------
strtgm: ld              a,(startlev)
        ld              (lev),a
        ld              a,$05
        ld              (lvs),a
        ld              hl,$0000
        ld              (score),hl
slev:
   ld              hl,&level1-$002C
        ld              a,(lev)
        ld              b,a
        ld              de,$002C
lslp:   add             hl,de
        djnz            lslp
        xor a
        ld              (cblk),a
        ld              de,level        ; decompress/load a level
        ld              b,$29
lllp:   ld              a,(hl)
        and             %11110000
        rra
        rra
        rra
        rra
        ld              (de),a
        inc             de
        ld              a,(hl)
        and             %00001111
        ld              (de),a
        inc             de
        inc             hl
        djnz            lllp
        dec             hl
        ld              bc,$0004
        ld              de,level+$0050
        ldir
        ld              hl,level+$0052
        ld              a,(hl)
        ld              (blks),a
        inc             hl
        ld              a,(hl)
        ld              (lblks),a
        ld              a,$28
        ld              (tickc),a
        ld              hl,$003C
        ld              (tick),hl
start:
  call &           clrgbuf
        CALL CLEARLCD
        call &           drwlev
	ld		bc,$0001
	ld		d,$3E
	call	&	VLine


	ld		bc,$0001
	ld		d,$51
	call		&Hline2

	ld		b,$00
      ld          c,63
	ld		d,$52
	call		&Hline2

	ld		bc,$5101
	ld          d,$3E
	call		&VLine

      call &DISP_GRAPH
;	ld		a,$32

dlp6:   
;     ld		c,a
;	ld		b,$53
;	ld		d,$5F
;	ld		e,c
;	call		iline
;	sub		$0E
;	cp		$08
;	jr		nz,dlp6
;	ld		c,$0E
;	ld		e,c
;	call		iline


        ld              bc,$1C53+13
        ld              hl,&scr
        CALL &DZM
        ld              bc,$0E53+13
        ld              hl,&levl
        CALL &DZM
        ld              bc,$0053+13
        ld              hl,&tcks
        CALL &DZM
        ld              hl,$2D5A+17
        ld              (CURSOR_X),hl
        ld              a,(lvs)
        LD H,0
            LD L,A
            call &disphl  ;display value in a at current position
        ld              hl,$1455+17
        ld              (CURSOR_X),hl
        ld              a,(lev)
        LD H,0
            LD L,A
            call &disphl
	ld		a,$05
	ld		(ssz),a

        ld              a,$64
        ld              (xc),a
        ld              a,$2E
        ld              (yc),a
        ld              hl,&lives
        ld              (loc),hl
        call &           dispsc
        call &           sprite2
        call &           sbtck
        xor a
        ld              (ovrflag),a
        ld              (winflag),a
        ld              a,(cblk)
        cp              $06
        jr              z,sblks
        ld              a,$01
        ld              (cblk),a
sblks:
  call &           update
        ld              hl,level+$0050
        ld              a,(hl)
        ld              (xc),a
        inc             hl
        ld              a,(hl)
        ld              (yc),a
        ld              a,$04
        ld              (ssz),a
        ld              hl,&ball
        ld              (loc),hl
        call &           sprite
        xor a
        ld              (dir),a

;------------ MAIN GAME LOOP ------------
main:
   CALL & DISP_GRAPH
        ld              a,(tickc)
        dec             a
        call &           z,sbtck
        ld              (tickc),a
        ld              a,(ovrflag)
        cp              $07
        jr              z,exit
        ld              a,(winflag)
        cp              $01
        jr              z,won
        call &           mvball

	ld a,0ffh
	out (1),a
 ld a,$BF          ; Check 2nd and more
 out (1),a
 in a,(1)
 cp 191
	jp & z,gmovr


	ld a,0ffh
	out (1),a
	ld a,0feh
	out (1),a
	in a,(1)
	cp 251
	jp & z,mright

	cp 253
	jp & z,mleft

 ld a,$FE
 out (1),a
 in a,(1)
 ld b,a
 ld a,$BF
 out (1),a
 in a,(1)
 or $0F
 and b
 bit 7,a
 jp z,&pause


	jr main
	        
exit:
   call &           clrgbuf
        CALL CLEARLCD
        ld              a,(lvs)
        dec             a
        jr              z,gmovr
        ld              (lvs),a
        jp &              start
gmovr:  CALL CLEARLCD
        ld              hl,$0502
        ld              (CURSOR_ROW),hl
        ld              hl,&losser
        CALL D_ZT_STR
        call &           shwscr
        call &           tsths
        call &           wkey
        jp &              menu

won:    ld              a,(tick)
        or a
        jr              z,nobon
        ld              b,a
bonus:  
        ld              hl,(score)
        inc             hl
        ld              (score),hl
        push            bc
        call &           sbtck
        call &           dispsc
        CALL & DISP_GRAPH
        pop             bc
        djnz            bonus   
nobon: 
 call &           clrgbuf
        CALL CLEARLCD
        ld              a,(lev)
        inc             a
        ld              (lev),a
        cp              28
        jp &              nz,slev
        ld              hl,1024
        ld              (CURSOR_ROW),hl
        ld              hl,&winner
        CALL  D_ZT_STR
        call &           shwscr
        call &           tsths
        call &           wkey
        jp &              menu

tsths:  ; test for a high score
        ld              hl,(score)  ;current score
        ld de,(&HI_SCORE)   ;high score
        ld bc,&HI_SCORE  ;it is just needed
        call CP_HL_DE
        ret c
        ret z

newhs:  ; set current score to the high score
        ld hl,(score)
        ld (&HI_SCORE),hl
        ld              hl,$0305
        ld              (CURSOR_ROW),hl
        ld              hl,&dnhs
        CALL D_ZT_STR

	  ld      	hl,$301C    
        ld       (CURSOR_X),hl  
        ld       hl,&EnterN     
	  ROM_CALL(D_ZM_STR)   
	  ld de, $0807			;initials entered at 5,4
 	  ld (CURSOR_ROW), de			;load location
	  ld hl,&highname		;hl points to initials

INPUT:
 ld b,0 	       ; B = number of letters entered so far

WaK:		       ; A simple string input routine follows
 push hl
 push bc	       ; GET_KEY destroys B. It doesn't on the TI-85 :-/
 call GET_KEY
 pop bc
 cp $02
 jr z,BackSpace
 cp $09
 jr z,NameDone
 cp $11
 jr nz,CheckLetter
 ld a,32
 pop hl
 jr PutLetter
CheckLetter:
 ld hl,&Letters
 push bc
 ld bc,26
 cpir
 ld d,c
 pop bc
 pop hl
 jr nz,WaK
 ld a,65
 add a,d
PutLetter:
 ld c,a
 ld a,b
 cp 3
 jr z,WaK
 ld (hl),c
 inc hl
 inc b
 ld a,c
 ROM_CALL(TX_CHARPUT)
 jr WaK
BackSpace:
 pop hl
 ld a,b
 or a
 jr z,WaK
 dec b
 dec hl
 push hl
 ld (hl),32
 ld hl,CURSOR_COL
 dec (hl)
 ld a,32
 ROM_CALL(TX_CHARPUT)
 dec (hl)
 pop hl
 jr WaK
NameDone:
 pop hl
 inc sp
 inc sp
        jp &              menu

Letters:
 .db $19,$21,$0A,$12,$1A,$22,$0B,$13,$1B,$23,$2B
 .db $0C,$14,$1C,$24,$2C,$0D,$15,$1D,$25,$2D,$0E
 .db $16,$1E,$26,$2E


shwscr: ; show the score (game over version)
        ld              hl,$0403
        ld              (CURSOR_ROW),hl
        ld              hl,&scr
        CALL D_ZT_STR
        ld              hl,(score)
        CALL D_HL_DECI
        ret

;------------ Pause ------------
pause: 
 call &           wkey
pausex:
 jp &              main


;------------ Subtract number of ticks ------------
sbtck:  ld              a,(tick)
        or a
        jr              z,sbts
        dec             a
        ld              (tick),a
sbts:   ld              bc,$065B+8
        ld              hl,&blank
        CALL &DZM
        ld              a,$55+16
        ld              (CURSOR_X),a
        ld              a,(tick)
        LD H,0
            LD L,A
            call &disphl
	ld		a,$28
            ret

;------------ Move the ball left ------------
mleft:  ld              a,(xc)
        cp              $01
        jr              z,mls
        call &           mball
        ld              a,(xc)
        dec	 a
        ld              (xc),a
        call &           tstblk
        or a
        jr              z,mlc
        ld              a,(xc)
        inc             a
        ld              (xc),a
mlc: 
   call &           mball
mls:
    jp &              main

;------------ Move the ball right ------------
mright: 
         ld              a,(xc)
        cp              77
        jr              z,mrs
        call &           mball
        ld              a,(xc)
      inc              a
        ld              (xc),a
        call &           tstblk
        or a
        jr              z,mrc
        ld              a,(xc)
        dec             a
        ld              (xc),a
mrc:  
  call &           mball
mrs:  
  jp &              main

;------------ Update on-screen status ------------
update: 
        call &           pshc
        ld              a,$06
        ld              (ssz),a
        ld hl,$3845+31
        ld              (xc),hl
        ld              hl,&blocks-$000C
        ld              a,(cblk)
        ld              b,a
        ld              de,$000C
udl1:   
        add             hl,de
        djnz            udl1
        ld              (loc),hl
        call &           sprite2
        ld              a,108
        ld              (xc),a
        ld              hl,(loc)
        ld              bc,$06
        add             hl,bc
        ld              (loc),hl
        call &           sprite2
        call &           popc
        ret

;------------ Check which block the ball is at ------------
;------------   and do whatever is necessary   ------------
tstblk: ld              hl,$0000
        ld              (tmp),hl
        ld              a,(xc)
        ld              d,a
        ld              e,$0A
        call &           div
        ld              a,d
        ld              (xc2),a
        ld              (tmp),a
        ld              a,(yc)
        ld              d,a
        ld              e,$06
        call &           div
        ld              a,d
        ld              (yc2),a
        or a
        jr              z,tbs1
        ld              b,d
tblp1:  
        push            bc
        ld              bc,$08
        add             hl,bc
        pop             bc
        djnz            tblp1
tbs1:   ld              bc,(tmp)
        add             hl,bc
        ld              bc,level
        add             hl,bc
        ld              a,(hl)
tbs2:   ld              (ovrflag),a
        cp              $03
        jp &              z,chg2
        cp              $05
        jp &              z,chg4
        cp              $09
        jp &              z,chg8
        push            af
        ld              b,a
        ld              a,(cblk)
        cp              b
        jp &              nz,tbx

;------------ Eliminate a Block ------------
        call &           pshc
        xor a
        ld              (hl),a
        ld              a,(xc2)
        or a
        jr              z,els1
        ld              b,a
ell1:   add             a,$09
        djnz            ell1
els1:   inc             a
        ld              (xc),a
        ld              a,(yc2)
        or a
        jr              z,els2
        ld              b,a
ell2:   add             a,$05
        djnz            ell2
els2:   inc             a
        inc             a
        ld              (yc),a
        ld              a,$06
        ld              (ssz),a
        ld              hl,&blocks
        ld              a,(cblk)
        dec             a
        jr              z,els3
        ld              b,a
        ld              de,$000C
ell3:   add             hl,de
        djnz            ell3
els3:   ld              (loc),hl
        push            hl
        call &           sprite
        pop             hl
        ld              de,$0006
        add             hl,de
        ld              (loc),hl
        ld              a,(xc)
        add             a,$0008
        ld              (xc),a
        call &           sprite
        call &           popc
        ld              de,(score)
        inc             de
        ld              (score),de
        call &           dispsc
        ld              a,(blks)
        or a
        jr              z,sb1
        dec             a
        call &           z,chg6
        ld              (blks),a
        jr              tbx
sb1:    ld              a,(lblks)
        dec             a
        ld              (lblks),a
        jr              nz,tbx
        ld              a,$01
        ld              (winflag),a
tbx:    pop             af
tbxx:   ret

chg2:   ; set the block type to 2
        push            af
        ld              a,(cblk)
        cp              $06
        jr              z,c2x
        call &           update
        ld              a,2
        ld              (cblk),a
        call &           update
c2x:    pop             af
        jr              tbxx

chg4:   ; set the block type to 4
        push            af
        ld              a,(cblk)
        cp              6
        jr              z,c4x
        call &           update
        ld              a,4
        ld              (cblk),a
        call &           update
c4x:    pop             af
        jr              tbxx

chg8:   ; set the block type to 8
        push            af
        ld              a,(cblk)
        cp              6
        jr              z,c8x
        call &           update
        ld              a,8
        ld              (cblk),a
        call &           update
c8x:    pop             af
        jr              tbxx

chg6:   ; set the block type to 6
        push            af
        call &           update
        ld              a,$06
        ld              (cblk),a
        call &           update
        pop             af
        ret

;----------- Save/Recall &xc and yc ------------

pshc:   ; save xc in ta and yc in tb
        ld              a,(xc)
        ld              (ta),a
        ld              a,(yc)
        ld              (tb),a
        ret
popc:   ; return ta to xc and tb to yc
        ld              a,(ta)
        ld              (xc),a
        ld              a,(tb)
        ld              (yc),a
        ret

;------------ Divide D by E ------------
div:    ; divide d by e and return d=answer e=remainder (d mod e)
        ld              a,d
        ld              c,0
dv1:    ld              b,e
        inc             a
dv2:    cp              b
        jr              z,dv3
        djnz            dv2
        dec             a
        sub             e
        inc             c
        jr              dv1
dv3:    ld              d,c
        ld              e,a
        dec             e
        ret

;------------ Turn on/off the ball ------------
mball:  ld              a,$04
        ld              (ssz),a
        ld              hl,&ball
        ld              (loc),hl
        call &           sprite
        ret

;------------ Move the ball vertically ------------
mvball: 
 call &           mball
        ld              a,(yc)
        cp              $02
        jr              nz,mn2
        xor a
        ld              (dir),a
mn2:    ld              a,(yc)
        cp              57
        jr              nz,mn57
        ld              a,$01
        ld              (dir),a
        jr              mup
mn57:   ld              a,(dir)
        or a
        jr              nz,mup
        ld              a,(yc)
        inc             a
        ld              (yc),a
        jr              cmx
mup:    ld              a,(yc)
        dec             a
        ld              (yc),a
cmx:
    call &           tstblk
        or a
        jr              z,cmxx
        ld              a,(dir)
        inc             a
        cp              $02
        jr              nz,cmxc
        xor a
cmxc:   ld              (dir),a
cmxx:
   call &           mball
        ret

;------------ Display the Score ------------
dispsc:
        ld              hl,36*256+101
        ld              (CURSOR_X),hl
        ld              hl,(score)
        call &           disphl
        ret
	ret



;------------ Draw the level (on/off) ------------
drwlev: ld              a,$06
        ld              (ssz),a
        ld              hl,513
        ld              (xc),hl
        ld              hl,level
        ld              (mloc),hl
        ld              b,$0A
dlp1:   push            bc
        ld              b,$08
dlp2:   push            bc
        ld              hl,(mloc)
        ld              a,(hl)
        or a
        jr              z,dskp
        ld              hl,&blocks
        ld              (loc),hl
        cp              $01
        jr              z,dcn
dlp3:   ld              bc,12
        add             hl,bc
        dec             a
        cp              $01
        jr              nz,dlp3
        ld              (loc),hl
dcn:
    call &           sprite
        ld              hl,(loc)
        ld              bc,$0006
        add             hl,bc
        ld              (loc),hl
        ld              a,(xc)
        add             a,$08
        ld              (xc),a
        call &           sprite
        ld              a,(xc)
        sub             $08
        ld              (xc),a
dskp:   ld              a,(xc)
        add             a,10
        ld              (xc),a
        ld              hl,(mloc)
        inc             hl
        ld              (mloc),hl
        pop             bc
        djnz            dlp2
        ld              a,(yc)
        add             a,$06
        ld              (yc),a
        ld              a,$01
        ld              (xc),a
        pop             bc
        djnz            dlp1
        ret

; This sprite routine was origionally by Movax.
; input:        ssz = height of the sprite
;               loc = location of the sprite in ram
;               yc = y coordinate of the sprite
;               xc = x coordinate of the sprite
; output:       puts a sprite on the graph buffer
sprite: ld              a,(yc)
        ld              l,a
        ld              e,a
        ld              h,$00
        ld              d,h
        add             hl,de
        add             hl,de
        add             hl,hl
        add             hl,hl
        ld              a,(xc)
        ld              e,a
        srl             e
        srl             e
        srl             e
        add             hl,de
        ld              de,GRAPH_MEM
        add             hl,de
        ld              b,$07
        and             b
        jr              z,align
; shift sprite if necessary
        ld              ix,(loc)
        ld              d,a
        ld              a,(ssz)
        ld              e,a
snal1:  ld              b,(ix+$00)
        ld              c,$00
        push            de
snal2:  srl             b
        rr              c
        dec             d
        jr              nz,snal2
        pop             de
        ld              a,b
        xor             (hl)
        ld              (hl),a
        inc             hl
        ld              a,c
        xor             (hl)
        ld              (hl),a
        ld              bc,$000B
        add             hl,bc
        inc             ix
        dec             e
        jr              nz,snal1
        jp &              sprtx

align:  ld              de,(loc)
        ld              a,(ssz)
        ld              b,a
salp:   ld              a,(de)
        xor             (hl)
        ld              (hl),a
        inc             de
        push            bc
        ld              bc,$000C
        add             hl,bc
        pop             bc
        djnz            salp
sprtx:  ret


sprite2:
      ld hl,(loc)
      ld a,(xc)
      ld b,a
      ld a,(yc)
      ld c,a

	push    BC
	push    DE
	ld      DE, $fc00
convdone:
	ld      A, 63
	sub     C
	ld      C, A
	push    HL
	push    HL
	call    FIND_PIXEL
	add     HL, DE
	ex      DE, HL
	pop     HL
	ld      B, 8
      push af
      ld      a,(ssz)
	ld      C, a
      pop af
	push    HL
	pop     IX
	ex      DE, HL
PS_NewRow:
	push    BC
	ld      D, (IX)
	inc     IX
	push    AF
	push    HL
PS_NewCol:
	rl      D
	ld      E, A
	jr      nc, PS_NextPixel
	xor     (HL)
	ld      (HL), A
PS_NextPixel:
	ld      A, E
	rrca
	jr      nc, PS_SameByte
	inc     HL
PS_SameByte:
	djnz    PS_NewCol
	pop     HL
	pop     AF
	ld      DE, 16
	add     HL, DE
	pop     BC
	dec     C
	jr      nz, PS_NewRow
	pop     HL
	pop     DE
	pop     BC
sprtx2:  ret


disphl:
        push de
        push hl
  ld de,(CURSOR_X)
  ld b,48                  ; 48 -> b
  ld c,4                   ; 4 -> c
  ld a,h                   ; h -> a
  or l                     ; If a=0 and l=0, then return zero
  jr z,DM_HL_3             ; If zero, then jump to DM_HL_3
  ld c,-1                  ; -1 -> c
  ld b,46                  ; 46 -> b
  jr DM_HL_NEXT2           ; Jump to DM_HL_NEXT2
DM_HL_INIT:
  CALL CP_HL_DE            ; cp hl,de
  jr c,DM_HL_NEXT2         ; If carry, then jump to DM_HL_NEXT2
  dec c                    ; c = c - 1
DM_HL_NEXT:
  ld b,47                  ; 47 -> b
DM_HL_NEXT2:
  inc c                    ; c = c + 1
  ld a,c                   ; c -> a
  or a                     ; If a=0, then return zero
  ld de,10000              ; 10000 -> de
  jr z,DM_HL_2a            ; If zero, then jump to DM_HL_2a
  cp 1                     ; If a=1, then return zero
  ld de,1000               ; 1000 -> de
  jr z,DM_HL_2a            ; If zero, then jump to DM_HL_2a
  cp 2                     ; If a=2, then return zero
  ld de,100                ; 100 -> de
  jr z,DM_HL_2a            ; If zero, then jump to DM_HL_2a
  cp 3                     ; If a=3, then return zero
  ld de,10                 ; 10 -> de
  jr z,DM_HL_2a            ; If zero, then jump to DM_HL_2a
  ld de,1                  ; 1 -> de
DM_HL_2a:
  ld a,b                   ; b -> a
  cp 46                    ; If a=46, then return zero
  jr z,DM_HL_INIT          ; If zero, then jump to DM_HL_INIT
DM_HL_2b:
  inc b                    ; b = b + 1
  CALL CP_HL_DE            ; cp hl,de
  jr c,DM_HL_3             ; If carry, then jump to DM_HL_3
  or a                     ; Reset carry flag
  sbc hl,de                ; hl = hl - de
  jr DM_HL_2b              ; Jump to DM_HL_2b
DM_HL_3:
  ld a,b                   ; b -> a
  ROM_CALL(M_CHARPUT)      ; Display the character
  ld a,c                   ; c -> a
  cp 4                     ; If a=4, then return zero
  jr nz,DM_HL_NEXT         ; If not zero, then jump to DM_HL_NEXT
        pop hl
        pop de
        ret

clrgbuf:
        ld hl,GRAPH_MEM
        ld de,GRAPH_MEM+1
        ld bc,$2FF
        ld (hl),0
        ldir
        ret


DZM:
      ld (CURSOR_X),bc
     CALL D_ZM_STR
     ret



;------------ Wait for a key press ------------
; I use this method instead of GetKey to prevent
; apd which would mess up all the variables.
wkey:   call           GET_KEY
        cp $09
        ret z
        jr wkey

;------------ Sprites ------------
ball:   .db             01100000b
        .db             11110000b
        .db             11110000b
        .db             01100000b
blocks: ; each block is 12 bytes
block1: .db             01111111b       ; width=10
        .db             10000000b       ; height=6
        .db             10000000b       ; clear
        .db             10000000b
        .db             10000000b
        .db             01111111b
blk1b:  .db             10000000b
        .db             01000000b
        .db             01000000b
        .db             01000000b
        .db             01000000b
        .db             10000000b
block2: .db             01111111b               ; spotted
        .db             11010101b
        .db             10101010b
        .db             11010101b
        .db             10101010b
        .db             01111111b
        .db             10000000b
        .db             01000000b
        .db             11000000b
        .db             01000000b
        .db             11000000b
        .db             10000000b
block3: .db             01111111b               ; change to spotted
        .db             11010111b
        .db             10101111b
        .db             11010111b
        .db             10101111b
        .db             01111111b
        .db             10000000b
        .db             11000000b
        .db             11000000b
        .db             11000000b
        .db             11000000b
        .db             10000000b
block4: .db             01111111b               ; bordered
        .db             10000000b
        .db             10111111b
        .db             10111111b
        .db             10000000b
        .db             01111111b
        .db             10000000b
        .db             01000000b
        .db             01000000b
        .db             01000000b
        .db             01000000b
        .db             10000000b
block5: .db             01111111b               ; change to bordered
        .db             10000111b
        .db             10110111b
        .db             10110111b
        .db             10000111b
        .db             01111111b
        .db             10000000b
        .db             11000000b
        .db             11000000b
        .db             11000000b
        .db             11000000b
        .db             10000000b
block6: .db             01111111b               ; last (thick border)
        .db             11111111b
        .db             11000000b
        .db             11000000b
        .db             11111111b
        .db             01111111b
        .db             10000000b
        .db             11000000b
        .db             11000000b
        .db             11000000b
        .db             11000000b
        .db             10000000b
block7: .db             01111111b               ; killer
        .db             11100111b
        .db             10000000b
        .db             10000000b
        .db             11100111b
        .db             01111111b
        .db             10000000b
        .db             11000000b
        .db             01000000b
        .db             01000000b
        .db             11000000b
        .db             10000000b
block8: .db             01111111b               ; spotted 2
        .db             11100110b
        .db             10011001b
        .db             11100110b
        .db             10011001b
        .db             01111111b
        .db             10000000b
        .db             01000000b
        .db             11000000b
        .db             01000000b
        .db             11000000b
        .db             10000000b
block9: .db             01111111b               ; change to spotted 2
        .db             11100111b
        .db             10011111b
        .db             11100111b
        .db             10011111b
        .db             01111111b
        .db             10000000b
        .db             11000000b
        .db             11000000b
        .db             11000000b
        .db             11000000b
        .db             10000000b
blockA: .db             01111111b               ; blocker
        .db             10111101b
        .db             11110111b
        .db             11011111b
        .db             11111011b
        .db             01111111b
        .db             10000000b
        .db             11000000b
        .db             11000000b
        .db             01000000b
        .db             11000000b
        .db             10000000b

lives:
        .db             00101000b               ; heart (for lives)
        .db             01111100b
        .db             01111100b
        .db             00111000b
        .db             00010000b

;------------ Dialog ------------

opt1:   .db             "2nd - Start Game",0
opt2:   .db             "ALPHA - Set Level",0
opt3:   .db             "EXIT - Exit",0
hscr:   .db             "High Score: ",0
abt:    .db             "by Joe Wingbermuehle",0
        .db             "TI-85 Port by Sam Heald",0
sls:    .db             "Level:",0
phlp1:  .db             "UP/DOWN - Select",0
phlp2:  .db             "2nd - Set",0
phlp3:  .db             "EXIT - Cancel",0
winner: .db             "You Won!",0
losser: .db             "Game Over",0
scr:    .db             "Score:",0
dnhs:   .db             "New High Score",0
levl:   .db             "Level:",0
tcks:   .db             "Bonus:",0
blank:  .db             "   ",0

HI_SCORE:
        .db $00, $00

level1:
	   .DB 0,116,71,0,0,114,39,0,5,68,68,48,1,0,0,16,0,6,96,0,0,6
 .DB 96,0,1,0,0,16,3,68,68,80,0,114,39,0,0,116,71,0,5,5,20,4
level2:
	  .DB 0,0,0,0,48,0,0,5,98,0,0,38,98,64,4,38,114,65,20,39,114
 .DB 65,20,39,98,64,4,38,98,0,0,38,80,0,0,3,0,0,0,0,44,54,24,8
level3:	
	  .DB 48,106,166,2,32,166,106,2,0,102,102,0,0,166,106,0,136,166,106,68
 .DB 136,0,0,68,137,0,0,84,0,0,0,0,0,0,0,0,17,122,167,17,75,50,17,12
level4:	
	  .DB 90,106,164,68,42,106,164,68,0,4,64,0,0,10,160,0,162,170,170,170
 .DB 162,167,58,170,0,1,16,0,0,0,0,0,161,26,161,17,166,106,166,102,77,44,18,7
level5:	
	  .DB 1,64,6,102,0,20,0,0,16,1,80,0,33,0,18,0,7,16,1,112,0,65,0,20,0,3
 .DB 16,1,0,0,33,0,102,96,2,16,170,170,170,42,75,50,23,6
level6:	
	  .DB 115,118,103,87,17,166,106,17,0,166,106,0,0,164,74,0,0,0,0,0,0
 .DB 0,0,0,0,0,0,0,17,17,17,17,34,39,114,34,39,39,114,114,76,40,24,6
level7:	
	.DB 102,106,0,21,102,106,0,17,138,170,0,0,0,0,0,0,0,0,0,0,170,170,170
 .DB 160,170,170,170,160,144,0,0,0,112,4,36,39,48,4,36,39,8,24,12,6
level8:	
	.DB 167,167,170,55,0,16,16,16,0,0,0,0,161,1,1,0,122,165,122,160,0,0
 .DB 0,0,0,0,0,0,122,68,34,167,122,71,114,167,122,70,98,167,6,8,14,2
level9:	
	.DB 147,160,0,7,0,16,0,4,0,16,170,170,0,16,160,34,0,16,128,37
 .DB 17,160,160,34,102,112,170,170,170,160,0,4,0,0,0,7,0,0,0,4,5,54,15,2
level10:
 .DB 0,128,2,0,4,160,10,64,4,160,10,64,1,80,3,0,1,118,103,0,1,118,103
 .DB 0,1,57,149,0,4,160,10,64,4,160,10,64,0,32,2,0,6,8,16,4

level11:
 .DB 32,0,0,5,64,0,0,7,112,6,130,67,112,122,170,170,112,136,121,132,0
 .DB 0,0,100,0,0,0,2,0,0,0,98,23,33,17,36,23,113,17,116,44,30,24,3
level12:
 .DB 7,65,16,0,116,0,1,17,64,0,0,17,64,0,0,113,0,33,64,49,0,118,112
 .DB 122,32,71,32,90,32,0,0,122,114,0,0,102,7,32,17,102,75,5,24,5	
level13:
 .DB 100,26,8,70,113,0,0,23,0,0,0,0,0,32,0,0,0,0,10,5,0,113,32,2,0
 .DB 167,160,169,64,112,0,0,0,128,0,4,96,120,48,118,6,50,14,4
level14:
 .DB 98,0,0,134,112,0,0,7,42,7,0,160,0,1,24,8,58,32,10,106,166,160,8
 .DB 169,32,33,16,0,10,0,112,168,112,0,0,7,98,0,0,134,37,30,16,6
level15:
 .DB 103,103,103,103,0,0,0,0,0,0,0,0,2,66,66,64,5,118,103,48,3,118
 .DB 103,80,4,36,36,32,0,0,0,0,0,0,0,0,118,118,118,118,8,5,12,12
level16:
 .DB 16,4,0,58,10,0,0,166,0,167,74,32,0,5,168,0,112,0,0,0,0,0,0
 .DB 7,0,42,80,0,8,164,122,0,106,0,0,160,169,0,64,1,5,47,10,2
level17:
 .DB 146,16,0,16,170,160,170,26,0,0,64,16,10,170,112,112,10,49,112,112
 .DB 20,112,160,112,168,112,0,112,114,122,170,160,102,117,129,0,170,170,170,170,75,4,13,2
level18:
 .DB 144,118,0,118,112,118,0,118,112,170,162,113,0,128,0,113,0,0,10,0,7
 .DB 163,160,0,0,122,0,161,0,160,0,118,10,0,7,118,64,0,5,118,44,54,6,7
level19:
 .DB 119,167,167,167,118,6,6,7,112,0,0,7,122,90,26,71,120,16,1
 .DB 71,120,16,1,71,120,161,169,167,112,0,0,7,112,96,96,103,122,122,122,119,42,30,12,6
level20:
 .DB 16,2,128,1,2,32,0,0,0,0,8,0,144,0,8,3,96,7,112,6,96,7
 .DB 112,6,48,32,0,9,0,32,0,0,0,0,2,32,16,8,32,1,15,27,16,4
level21:
 .DB 10,144,8,136,1,166,74,136,161,26,68,168,58,16,160,7,0,80,10,4,0,10
 .DB 0,116,7,0,160,0,2,160,74,0,2,42,68,164,98,34,164,68,5,3,28,2
level22:
 .DB 72,101,118,130,98,97,118,70,0,112,121,0,0,0,0,0,0,0,0,0,0,0,0
 .DB 0,0,0,0,0,0,151,7,0,100,103,22,38,40,103,54,132,75,31,14,12
level23:
 .DB 48,0,7,98,112,0,0,0,170,170,0,10,71,170,7,164,0
 .DB 0,10,96,5,0,2,0,10,170,0,0,6,166,0,0,0,162,0,0,116,167,7,119,13,5,6,4
level24:
 .DB 148,136,34,67,0,0,0,0,0,0,0,0,10,122,122,112,0,6,160
 .DB 0,0,1,160,0,0,6,160,0,2,1,160,128,2,6,160,128,146,65,165,131,54,10,16,3
level25:
 .DB 64,32,112,80,0,0,0,0,4,8,10,8,0,0,0,0,144,112,64,128
 .DB 0,0,0,0,8,4,3,6,0,0,0,0,32,32,112,16,0,0,0,0,75,55,12,1
level26:
 .DB 0,0,3,117,0,0,0,112,71,0,0,112,39,0,0,112,71,1,16,112,135,1,16
 .DB 112,71,0,0,112,39,0,0,112,71,0,0,0,103,144,0,0,54,55,11,1
level27:
 .DB 56,87,64,136,24,0,0,0,0,0,0,0,0,0,80,0,112,166,106,7,0,4,0,0
 .DB 0,0,0,0,0,0,0,0,0,5,0,34,34,5,117,41,15,36,12,2

DISP_GRAPH:
 ei
 halt
 halt
 halt
 ld de,$fc00
 call &FillDE
 inc de
 ld hl,GRAPH_MEM
 ld a,64
copy_loop
 ld bc,11
 ldir
 inc de
 inc de
 inc de
 inc hl
 call &FillDE
 inc de
 call &FillDE
 inc de
 dec a
 jr nz,copy_loop
 ret

FillDE:
 push af
 ld a,$00
 ld (de),a
 pop af
 ret

;horizontal line: B = start x, D = len, C = y

Hline:
	ld      A, 63
	sub     C
	ld      C, A
	call    FIND_PIXEL
	ld      B, D
	ld      DE, $fc00
	add     HL, DE
	ld      C, A
HLineLoop:
	ld      A, (HL)
	or      C
	ld      (HL), A
	rrc     C
	jr      nc, HLineLoop_
	inc     HL
HLineLoop_:
	djnz    HLineLoop
	ret

Hline2:
	ld      A, 63
	sub     C
	ld      C, A
	call   & FIND_PIXEL2
	ld      B, D
	ld      DE, GRAPH_MEM
	add     HL, DE
	ld      C, A
      jr HLineLoop




;vertical line: B = x, C = start y, D = len

VLine:
	ld      A, 63
	sub     C
	ld      C, A
	call   & FIND_PIXEL2
	ld      B, D
	ld      DE, GRAPH_MEM
	add     HL, DE
	ld      C, A
	ld      DE, 12
VLineLoop:
	ld      A, (HL)
	or      C
	ld      (HL), A
	add     HL, DE
	djnz    VLineLoop
	ret


FIND_PIXEL_DATA:
         .db      128,64,32,16,8,4,2,1
FIND_PIXEL2:
         push     bc
	   push     de
         ld       a,b
         and      7
         ld       hl,&FIND_PIXEL_DATA
         ld       e,a
         ld       d,0
         add      hl,de
         ld       e,(hl)            ; E = pixel mask
         ld       a,63
         sub      c
         ld       c,a
         add      a,a
         add      a,c               ; A = 3 * Y
         ld       l,a
         ld       h,0
         add      hl,hl
         add      hl,hl             ; HL = 12 * Y
         ld       a,b
         ld       b,0
         rrca
         rrca
         rrca
         and      15
         ld       c,a
         add      hl,bc
         ld       a,e               ; A = pixel mask
         pop      de
         pop      bc
         ret

highname: .db "SAM",0
EnterN:
 .db "Enter Your Initials:",0

.end

